#ifndef _UDTYPES_H__
#define _UDTYPES_H__

typedef struct{
  int numSamples;
  int aquisitionMatrixSize[3];
  int reconstructionMatrixSize[3];
  float kMax;
  int gridSize[3];
  float oversample;
  float kernelWidth;
  int binsize;
  int useLUT;
  int sync;
}parameters;

typedef struct{
  float real;
  float imag;
  float kX;
  float kY;
  float kZ;
  float sdc;
} ReconstructionSample;

typedef struct{
  float real;
  float imag;
} cmplx;

typedef struct{
  float* real;
  float* imag;
  float* kx;
  float* ky;
  float* kz;
  float* sdc;
} samplePtArray;
#endif
