




#define CUERR { cudaError_t err; \
  if ((err = cudaGetLastError()) != cudaSuccess) { \
  printf("CUDA error: %s, line %d\n", cudaGetErrorString(err), __LINE__); \
  return -1; }}


__global__ void block2D_naive(float fac,float *A0,float *Anext, int nx, int ny, int nz,
    int tx, int ty, int tz);
	
__global__ void block2D_opt_1(float fac,float *A0,float *Anext, int nx, int ny, int nz,
    int tx, int ty, int tz);
	
__global__ void block2D_opt_2(float fac,float *A0,float *Anext, int nx, int ny, int nz,
    int tx, int ty, int tz);
	
__global__ void block2D_opt_3(float fac,float *A0,float *Anext, int nx, int ny, int nz,
    int tx, int ty, int tz);

__global__ void block2D_shared(float fac,float *A0,float *Anext, int nx, int ny, int nz,
    int tx, int ty, int tz);